# coding: utf-8

"""
    Vayu API

    The Vayu API is a RESTful API that allows you to submit events for processing and storage & manage billing related entities.           The API is secured using the Bearer Authentication scheme with JWT tokens.           To obtain a JWT token, please contact Vayu at team@withvayu.com

    The version of the OpenAPI document: 1.0.0
    Contact: dev@withvayu.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.events_dry_run_response_schema_inner_event import EventsDryRunResponseSchemaInnerEvent
from openapi_client.models.events_dry_run_response_schema_inner_meter_with_values_inner import EventsDryRunResponseSchemaInnerMeterWithValuesInner
from typing import Optional, Set
from typing_extensions import Self

class EventsDryRunResponseSchemaInner(BaseModel):
    """
    EventsDryRunResponseSchemaInner
    """ # noqa: E501
    event: EventsDryRunResponseSchemaInnerEvent
    matched_customer: Optional[StrictStr] = Field(default=None, alias="matchedCustomer")
    meter_with_values: List[EventsDryRunResponseSchemaInnerMeterWithValuesInner] = Field(alias="meterWithValues")
    __properties: ClassVar[List[str]] = ["event", "matchedCustomer", "meterWithValues"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EventsDryRunResponseSchemaInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of event
        if self.event:
            _dict['event'] = self.event.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in meter_with_values (list)
        _items = []
        if self.meter_with_values:
            for _item in self.meter_with_values:
                if _item:
                    _items.append(_item.to_dict())
            _dict['meterWithValues'] = _items
        # set to None if matched_customer (nullable) is None
        # and model_fields_set contains the field
        if self.matched_customer is None and "matched_customer" in self.model_fields_set:
            _dict['matchedCustomer'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EventsDryRunResponseSchemaInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "event": EventsDryRunResponseSchemaInnerEvent.from_dict(obj["event"]) if obj.get("event") is not None else None,
            "matchedCustomer": obj.get("matchedCustomer"),
            "meterWithValues": [EventsDryRunResponseSchemaInnerMeterWithValuesInner.from_dict(_item) for _item in obj["meterWithValues"]] if obj.get("meterWithValues") is not None else None
        })
        return _obj


