# coding: utf-8

"""
    Vayu API

    The Vayu API is a RESTful API that allows you to submit events for processing and storage & manage billing related entities.           The API is secured using the Bearer Authentication scheme with JWT tokens.           To obtain a JWT token, please contact Vayu at team@withvayu.com

    The version of the OpenAPI document: 1.0.0
    Contact: dev@withvayu.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from openapi_client.models.list_meters_response_schema_meters_inner import ListMetersResponseSchemaMetersInner
from typing import Optional, Set
from typing_extensions import Self

class ListMetersResponseSchema(BaseModel):
    """
    ListMetersResponseSchema
    """ # noqa: E501
    meters: List[ListMetersResponseSchemaMetersInner]
    total: Union[StrictFloat, StrictInt]
    has_more: StrictBool = Field(alias="hasMore")
    next_cursor: Optional[StrictStr] = Field(default=None, alias="nextCursor")
    __properties: ClassVar[List[str]] = ["meters", "total", "hasMore", "nextCursor"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ListMetersResponseSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in meters (list)
        _items = []
        if self.meters:
            for _item in self.meters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['meters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ListMetersResponseSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "meters": [ListMetersResponseSchemaMetersInner.from_dict(_item) for _item in obj["meters"]] if obj.get("meters") is not None else None,
            "total": obj.get("total"),
            "hasMore": obj.get("hasMore"),
            "nextCursor": obj.get("nextCursor")
        })
        return _obj


