# coding: utf-8

"""
    Vayu API

    The Vayu API is a RESTful API that allows you to submit events for processing and storage & manage billing related entities.           The API is secured using the Bearer Authentication scheme with JWT tokens.           To obtain a JWT token, please contact Vayu at team@withvayu.com

    The version of the OpenAPI document: 1.0.0
    Contact: dev@withvayu.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from openapi_client.models.event import Event
from openapi_client.models.send_events_response_schema_invalid_events_inner import SendEventsResponseSchemaInvalidEventsInner
from typing import Optional, Set
from typing_extensions import Self

class SendEventsResponseSchema(BaseModel):
    """
    SendEventsResponseSchema
    """ # noqa: E501
    valid_events: List[Event] = Field(description="An array of events that were successfully processed and sent to the queue.", alias="validEvents")
    invalid_events: List[SendEventsResponseSchemaInvalidEventsInner] = Field(description="An array of events that failed validation and were not sent to the queue. Each object contains the event and the error message.", alias="invalidEvents")
    __properties: ClassVar[List[str]] = ["validEvents", "invalidEvents"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SendEventsResponseSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in valid_events (list)
        _items = []
        if self.valid_events:
            for _item in self.valid_events:
                if _item:
                    _items.append(_item.to_dict())
            _dict['validEvents'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in invalid_events (list)
        _items = []
        if self.invalid_events:
            for _item in self.invalid_events:
                if _item:
                    _items.append(_item.to_dict())
            _dict['invalidEvents'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SendEventsResponseSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "validEvents": [Event.from_dict(_item) for _item in obj["validEvents"]] if obj.get("validEvents") is not None else None,
            "invalidEvents": [SendEventsResponseSchemaInvalidEventsInner.from_dict(_item) for _item in obj["invalidEvents"]] if obj.get("invalidEvents") is not None else None
        })
        return _obj


